var passwordMain=document.createElement('div');
var passwordMode;
var passwordManual=document.createElement('div');
var passwordAuto=document.createElement('div');

function updatePassword()
{
	if (!passwordMode) return;
	try{
		passwordMain.replaceChild(passwordMode.checked?passwordAuto :passwordManual,
	                                  passwordMode.checked?passwordManual:passwordAuto);
	}catch(e) {};
}

var pwgenPath=document.location.protocol +
              '//' +
	      document.location.host +
	      '/fbi-bin/index.scm/pwgen';

function generatePassword()
{
	var xmlhttp = makeXMLHttpRequest();
	if (!xmlhttp) return;
	xmlhttp.open('GET',pwgenPath+'?async=yes',true);
	xmlhttp.onreadystatechange = function()
	                             {
				     	if (xmlhttp.readyState == 4)
					{
					     	var answer = xmlhttp.responseXML;
						if (xmlhttp.status == 200 && answer)
						{
							var auto_password = answer.getElementsByTagName('input')[0];
							if (auto_password)
							{
								auto_password = auto_password.getAttribute('value');
								auto_inputs = passwordAuto.getElementsByTagName('input');
								auto_inputs[0].value = auto_password;//hidden
								auto_inputs[1].value = auto_password;//text
							}
						}
						delete xmlhttp;
					}
				     };
	xmlhttp.send('');
}

function initPassword()
{
	var old = document.getElementById('ajax-password');
	if (!old) return;

	//replace new div
	passwordManual = old.parentNode.replaceChild(passwordMain,old);
	if (!passwordManual) return;

	//two modes of the password setup
	passwordAuto.innerHTML='<input type="hidden" name="passwd1">'+
                               '<br/>'+
			       '<input type="text" name="passwd2" class="text">'+
                               '<input type="button" value="'+ _("Generate")+'" '+
			       'onclick="generatePassword();" class="btn">';

	//mode selector
	var selector = document.createElement('div');
	selector.innerHTML='<input type="checkbox" name="ajax-password-mode" onclick="updatePassword();"/>'+
	                   _("Generate automatically")+
			   '<br/>';
	passwordMode = selector.getElementsByTagName('input')[0];

	passwordMain.appendChild(selector);
	passwordMain.appendChild(passwordManual);
}

addEvent(window,'load',initPassword);
